package com.krispot.client;


import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.Window;
import com.krispot.client.resource.KriCSS;
import com.krispot.client.resource.KriConstants;
import com.krispot.client.resource.KriHelp;
import com.krispot.client.resource.KriRegExp;
import com.krispot.client.resource.KriResources;
import com.krispot.client.ui.KriDialogBox;
import com.krispot.client.ui.KriHelpMessage;
import com.krispot.client.ui.KriShowMessage;
import com.krispot.client.ui.KriWaiting;

public interface Kri {
	
	public final static int DEBUG = 0;
	/** 
	 * Following code is use to show the Wait POPUP when request sent to Server 
	 */
	public final static KriServiceAsync kriService = GWT.create(KriService.class);
	/**
	 * Following code is use to show the Wait POPUP when request sent to Server 
	 */
	static KriCSS css = KriResources.INSTANCE.css();
	
	/**
	 * Following constant is use to show the help message for input field.
	 * <font class='helpMessage'/>First Name of your Full Name e.g. <b>John</b> from John Quincy Adams</font> 	
	 */
	static KriHelp help = GWT.create(KriHelp.class);
	
	/**
	 * Following constant is use validate the input type 	
	 */
	static KriRegExp regExp = GWT.create(KriRegExp.class);
	
	/**
	 * Following constant is use to show the Success/Error messages on the page 	
	 */
	static KriShowMessage showMessage = new KriShowMessage("&nbsp;");
	
	/**
	 * If help messages are associated with any input type.
	 * Like for Cell Number should be +91 9717179084 etc  	
	 */
	static KriHelpMessage helpMessage = new KriHelpMessage("&nbsp;");
	
	/**
	 * Use Kri.waiting.showPopUp() or Kri.waiting.hidePopUp() for waiting bar	
	 */
	static KriWaiting waiting = new KriWaiting(false, true);
	
	/**
	 * you can get the application context & development URL for eclipse from KriConstants.properties
	 */
	static KriConstants constants = GWT.create(KriConstants.class);
	static String appCtx = constants.appCtx();
	static String appEnv = constants.appEnv();
	
	/**
	 * Use Kri.ChangeURL.path("login.html") of the HTML file which you want to call from after some event.
	 */
	class ChangeURL {
		public static void path(String url) {
			Window.Location.replace(appCtx + url + appEnv);
		}
	}
	
	/**
	 * Use 	
	 * @Override
	 * public void onFailure(Throwable caught) {
	 *    Failure.handler(caught);
	 * } 
 	 */
	static class Failure {
		public static void handler(Throwable caught) {
			Kri.waiting.hidePopUp();
			KriDialogBox.info(KriDialogBox.TITLE_WARNING, caught.getMessage(), caught.toString());
		}
	}
	
}
