package com.krispot.client.ui;
import java.util.ArrayList;
import java.util.List;

import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.MouseOutEvent;
import com.google.gwt.event.dom.client.MouseOutHandler;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.PushButton;
import com.krispot.client.common.Reset;
import com.krispot.client.common.RoleAction;
import com.krispot.client.common.Validate;


public class KriButton extends Composite implements RoleAction
{  
	public final static String ADD16 = "images/add16.png";
	public final static String UPDATE16 = "images/update16.png";
	public final static String RESET16 = "images/reset16.png";
	
	private List<Validate> validateList = new ArrayList<Validate>();
	private List<Reset> resetItem = new ArrayList<Reset>();
	private PushButton button = new PushButton();
	private String roleId;
	private String text;
	private String image;
	
	{
		button.addMouseOutHandler(new MouseOutHandler() {
			@Override
			public void onMouseOut(MouseOutEvent event) {
		    	 if(image == null) {
		    		 button.setHTML("<table width='100%'><tr><td style='vertical-align: middle;text-align:center'>"+new HTML(text)+"</td></tr></table>");
		    	 }else {
		    		 button.setHTML("<table width='100%'><tr><td><img src='"+image+"' /></td><td style='vertical-align: middle;'>"+new HTML(text)+"</td></tr></table>");
		    	 }
			}
		});
	}

    public KriButton(String text, int width, int height, ClickHandler handler) {
    	this(text, width, height);
    	button.addClickHandler(handler);
    }
    public KriButton(String text, int width, int height) {  
        button.setHTML("<table width='100%'><tr><td style='vertical-align: middle;text-align:center'>"+new HTML(text)+"</td></tr></table>");
        button.setSize(width + "px", height + "px");
        this.text = text;
        this.initWidget(button);  
    }
    public KriButton(String text, ClickHandler handler) {
    	this(text);
    	button.addClickHandler(handler);
    }
    public KriButton(String text) {  
        button.setHTML("<table width='100%'><tr><td style='vertical-align: middle;text-align:center'>"+new HTML(text)+"</td></tr></table>");
        button.setSize("80px", "25px");
        this.text = text;
        this.initWidget(button);  
    }
    public KriButton(String image, String text, ClickHandler handler) {
    	this(image, text);
    	button.addClickHandler(handler);
    }
    public KriButton(String image, String text) {  
        button.setHTML("<table width='100%'><tr><td><img src='"+image+"' /></td><td style='vertical-align: middle;'>"+new HTML(text)+"</td></tr></table>");
        button.setSize("100px", "100%");
        this.text = text;
        this.image = image;
        this.initWidget(button);  
    }
    public KriButton(String image, String text, int width, int height, ClickHandler handler) {
    	this(image, text, width, height);
    	button.addClickHandler(handler);
    }
     public KriButton(String image, String text, int width, int height)
     {  
         button.setHTML("<table width='100%'><tr><td><img src='"+image+"' /></td><td style='vertical-align: middle;'>"+new HTML(text)+"</td></tr></table>");
         button.setPixelSize(width, height);
         this.text = text;
         this.image = image;
         this.initWidget(button);  
     }
     public KriButton(String roleId, String image, String text, int width, int height) {
		this(image, text, width, height);
		this.roleId = roleId;
//		setEnabled(false);
	 }
	 public void setEnabled(boolean enabled) {
//		 if(PERMISSION.get(this.roleId)!=null && PERMISSION.get(this.roleId)) {
//			 if(enabled)
				 button.setEnabled(enabled);
//			 else
//				 button.setEnabled(PERMISSION.get(this.roleId));
//		 }else{
//			 button.setEnabled(false);
//		 }
     }
     public void add(Validate... validate) {
    	 for(int i=0; i<validate.length; i++){
    		 validateList.add(validate[i]);
    	 }
     }
     public PushButton getSource() {
    	 return button;
     }
     public void reset(Reset... obj) {
    	 for(int i=0; i<obj.length; i++){
    		 resetItem.add(obj[i]);
    	 }
     }
     public void reset(Reset obj) {
		 resetItem.add(obj);
     }
     public void addClickHandler(ClickHandler clickHandler) {
    		button.addClickHandler(clickHandler);	
     }
     public String getText() {
 		return text;
 	 }
     public void setText(String text) {
    	 this.text = text;
    	 if(image == null) {
    		 button.setHTML("<table width='100%'><tr><td style='vertical-align: middle;'>"+new HTML(text)+"</td></tr></table>");
    	 }else {
    		 button.setHTML("<table width='100%'><tr><td><img src='"+image+"' /></td><td style='vertical-align: middle;'>"+new Label(text).getElement().getInnerHTML()+"</td></tr></table>");
    	 }
 	 }
	 public boolean isValidate() {
    	 for(Validate obj:validateList) {
    		 if(!obj.isValidate())
    			 return false;
    	 }
    	 return true;
     }
     public void reset() {
    	 for(Reset obj:resetItem) {
    		 obj.reset();
    	 }
     }
 } 
