package com.krispot.client.ui;

import com.google.gwt.event.logical.shared.ValueChangeEvent;
import com.google.gwt.event.logical.shared.ValueChangeHandler;
import com.google.gwt.user.client.ui.CheckBox;
import com.krispot.client.common.Reset;

public class KriCheckBox<T> extends CheckBox implements Reset {
	public KriCheckBox(final String roleId, final java.util.HashMap<String, Boolean> hashMap) {
		super(roleId);
		super.addValueChangeHandler(new ValueChangeHandler<Boolean>(){
			public void onValueChange(ValueChangeEvent<Boolean> event) {
				hashMap.put(roleId, event.getValue());
			}
		});
	}
	private T dto;
	public KriCheckBox(T dto, String label) {
		super(label);
		this.dto = dto;
		setStyleName("CursorAsHand");
		setTitle(label);
	}
	public KriCheckBox() {
		super();
	}
	public T getDto() {
		return dto;
	}
	@Override
	public void reset() {
		super.setChecked(false);
	}
}
