package com.krispot.client.ui;

import java.util.Date;

import com.google.gwt.dom.client.Style;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.dom.client.Style.VerticalAlign;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.event.logical.shared.ValueChangeEvent;
import com.google.gwt.event.logical.shared.ValueChangeHandler;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.datepicker.client.DateBox;
import com.google.gwt.user.datepicker.client.DateBox.DefaultFormat;
import com.krispot.client.common.CSSStyle;
import com.krispot.client.common.Reset;
import com.krispot.client.common.Validate;
import com.krispot.client.common.Value;
	
public class KriDateBox extends HorizontalPanel implements KeyUpHandler, Validate, Reset, Value, ValueChangeHandler<Date> {
	
	private DateBox dateBox = new DateBox();
	private Image image = new Image("images/correct16.png");
	private String regExp;
	private KriShowMessage errorMessageOn;
	private String errorMessage;
	
	public void setEnabled(boolean enabled) {
		dateBox.setEnabled(enabled);
	}
	public void setFormat(DefaultFormat format) {
		dateBox.setFormat(format);
	}
	public KriDateBox() {
		super();
	}
	public KriDateBox(String regExp, String errorMessage, KriShowMessage errorMessageOn) {
		
		super();
		this.regExp = regExp;
		this.errorMessageOn = errorMessageOn;
		this.errorMessage = errorMessage;
		Style styleTextBox = dateBox.getElement().getStyle();
		styleTextBox.setBorderWidth(0, Unit.PX);
		
		dateBox.getTextBox().addKeyUpHandler(this);
		dateBox.addValueChangeHandler(this);
		HorizontalPanel horizontalPanel = new HorizontalPanel();
		horizontalPanel.add(dateBox);
		horizontalPanel.setCellWidth(dateBox, "150px");
		horizontalPanel.setCellVerticalAlignment(dateBox, HasVerticalAlignment.ALIGN_MIDDLE);
		horizontalPanel.add(image);
		
		image.setVisible(false);
		Style styleImage = dateBox.getElement().getStyle();
		styleImage.setVerticalAlign(VerticalAlign.MIDDLE);
		horizontalPanel.setCellWidth(image, "20px");
		
		horizontalPanel.setCellVerticalAlignment(image, HasVerticalAlignment.ALIGN_MIDDLE);
		
		add(horizontalPanel);
		setCellVerticalAlignment(horizontalPanel, HasVerticalAlignment.ALIGN_MIDDLE);
		
		CSSStyle.maskedTextBox(this);
		
		setBorderWidth(0);
		setSpacing(0);
		setHeight("28px");
		
	}
	public String getText() {
		return dateBox.getTextBox().getText();
	}
	
	public void setText(String str) {
		dateBox.getTextBox().setText(str);
		image.setVisible(false);
	}
	
	
	public int validate(int validateAllField) {
		
		String str = (""+this.getText()).trim();
		if(str.matches(regExp)) {
			image.setUrl("images/correct16.png");
			errorMessageOn.setError("&nbsp;");
			return validateAllField;
		}else{
			errorMessageOn.setError(errorMessage);
			image.setUrl("images/wrong16.png");
			return ++validateAllField;
		}	
	}
	@Override
	public void onKeyUp(KeyUpEvent event) {
		doIt();
	}
	
	void doIt() {
		String str = (""+this.getText()).trim();
		if(str.length() == 0) {
			image.setVisible(false);
			errorMessageOn.setError("&nbsp;");
		}else{
			validate(0);
			image.setVisible(true);
		}
	}
	
	@Override
	public boolean isValidate() {
		return (validate(0)==0);
	}
	
	@Override
	public void reset() {
		dateBox.getTextBox().setText("");
		image.setVisible(false);
	}

	@Override
	public String getValue() {
		return dateBox.getTextBox().getText();
	}
	
	public void setValue(Date date) {
		dateBox.setValue(new Date());
	}
	
	@Override
	public void onValueChange(ValueChangeEvent<Date> event) {
		doIt();
	}
}
