package com.krispot.client.ui;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.i18n.client.LocaleInfo;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.krispot.client.common.UserAction;

public class KriDialogBox {
	
	public static final String TITLE_WARNING = "Warning";
	public static final String TITLE_INFO = "Information";
    
	public static <T> void confirm(String type, String addToTitle, String msg, final UserAction userAction, final AsyncCallback<T> asyncCallback) {
		final DialogBox dialogBox = new DialogBox();
		KriButton yesButton = new KriButton("images/yes16.png", "Yes", 80, 25);
		KriButton noButton = new KriButton("images/no16.png", "No", 80, 25);
		dialogBox.setText("Confirm This Change - "+( (addToTitle==null) ? "" : addToTitle) );
		    yesButton.setWidth("80px");
		    noButton.setWidth("80px");
		
	    HorizontalPanel horizontalPanel = new HorizontalPanel();
	    VerticalPanel verticalPanel = new VerticalPanel();
	    
	    HTML details = new HTML("<b>Are you Sure ... !!&nbsp;&nbsp;&nbsp;&nbsp;"+addToTitle+"</b><br>"+msg);
	    Image image = new Image("images/warning64.png");
	    verticalPanel.add(details);
	    
	    HorizontalPanel hPanel = new HorizontalPanel();
		    hPanel.setWidth("100px");
		    hPanel.setSpacing(10);
		    hPanel.setBorderWidth(0);
		    hPanel.add(yesButton);
		    hPanel.add(noButton);
	    
	    horizontalPanel.setWidth("100%");
	    horizontalPanel.add(image);
		    verticalPanel.add(details);
		    verticalPanel.add(hPanel);
		    verticalPanel.setBorderWidth(0);
		    verticalPanel.setSize("100%", "130px");
		    verticalPanel.setCellHorizontalAlignment( hPanel, HasHorizontalAlignment.ALIGN_RIGHT);
		    verticalPanel.setCellVerticalAlignment( hPanel, HasVerticalAlignment.ALIGN_BOTTOM);
	    horizontalPanel.setCellWidth( image, "100px");
	    horizontalPanel.setCellHorizontalAlignment( details, HasHorizontalAlignment.ALIGN_LEFT);
	    
	    horizontalPanel.add(verticalPanel);
	    
	    horizontalPanel.setSize("500px", "120px");
	    horizontalPanel.setSpacing(4);
	    horizontalPanel.setBorderWidth(0);
	    dialogBox.setWidget(horizontalPanel);

	    yesButton.addClickHandler(new ClickHandler() {
			@Override
			public void onClick(ClickEvent event) {
					userAction.execute(asyncCallback);
					dialogBox.hide();
					dialogBox.clear();
			}
		});
	    noButton.addClickHandler(new ClickHandler() {
			@Override
			public void onClick(ClickEvent event) {
					dialogBox.hide();
					dialogBox.clear();
			}
		});

	    if (LocaleInfo.getCurrentLocale().isRTL()) {
	    	horizontalPanel.setCellHorizontalAlignment( horizontalPanel, HasHorizontalAlignment.ALIGN_RIGHT);
	    } else {
	    	horizontalPanel.setCellHorizontalAlignment( horizontalPanel, HasHorizontalAlignment.ALIGN_RIGHT);
	    }	
	    dialogBox.show();
	    dialogBox.center();
	}
	public static void info(String type, String addToTitle, String msg) {
		final DialogBox dialogBox = new DialogBox();
		KriButton okButton = new KriButton("images/yes16.png", "Ok", 80, 25);
		dialogBox.setText("Information - "+( (addToTitle==null) ? "" : addToTitle) );
			okButton.setWidth("80px");
		
	    HorizontalPanel horizontalPanel = new HorizontalPanel();
	    VerticalPanel verticalPanel = new VerticalPanel();
	    
	    HTML details = new HTML(msg);
	    Image image = new Image("images/info64.png");
	    verticalPanel.add(details);
	    
	    HorizontalPanel hPanel = new HorizontalPanel();
		    hPanel.setWidth("100px");
		    hPanel.setSpacing(10);
		    hPanel.setBorderWidth(0);
		    hPanel.add(okButton);
	    
	    horizontalPanel.setWidth("100%");
	    horizontalPanel.add(image);
		    verticalPanel.add(details);
		    verticalPanel.add(hPanel);
		    verticalPanel.setBorderWidth(0);
		    verticalPanel.setSize("100%", "130px");
		    verticalPanel.setCellHorizontalAlignment( hPanel, HasHorizontalAlignment.ALIGN_RIGHT);
		    verticalPanel.setCellVerticalAlignment( hPanel, HasVerticalAlignment.ALIGN_BOTTOM);
	    horizontalPanel.setCellWidth( image, "100px");
	    horizontalPanel.setCellHorizontalAlignment( details, HasHorizontalAlignment.ALIGN_LEFT);
	    
	    horizontalPanel.add(verticalPanel);
	    
	    horizontalPanel.setSize("500px", "120px");
	    horizontalPanel.setSpacing(4);
	    horizontalPanel.setBorderWidth(0);
	    dialogBox.setWidget(horizontalPanel);
	    

	    ClickHandler clickHandler = new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				dialogBox.hide();
			}
	    	
	    };
	    okButton.addClickHandler(clickHandler);

	    if (LocaleInfo.getCurrentLocale().isRTL()) {
	    	horizontalPanel.setCellHorizontalAlignment( horizontalPanel, HasHorizontalAlignment.ALIGN_RIGHT);
	    } else {
	    	horizontalPanel.setCellHorizontalAlignment( horizontalPanel, HasHorizontalAlignment.ALIGN_RIGHT);
	    }	
	    dialogBox.show();
	    dialogBox.center();
	}
}
