package com.krispot.client.ui;

import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.HTMLTable;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.Widget;

public class KriFlexTable extends FlexTable {
	public final static int WITH_HEADER = 1;
	public final static int WITHOUT_HEADER = 0;
	
	public KriFlexTable(){
		
	}
	public KriFlexTable(String[] columnHeading){
		for(String column:columnHeading){
			addColumn(column, "FlexTable-Header");
		}
	}
	
	public void applyDataRowStyles2TwoRows(int header) {
	    HTMLTable.RowFormatter rf = super.getRowFormatter();
	    	for (int row = header; row < super.getRowCount(); ++row) {
		        rf.removeStyleName(row, "FlexTable-EvenRow");
		        rf.removeStyleName(row, "FlexTable-OddRow");
		    }
	    	boolean check = true;
		    for (int row = header; row < super.getRowCount(); ++row) {
		      if (check) {
		    	  rf.addStyleName(row, "FlexTable-OddRow");
		    	  rf.addStyleName(++row, "FlexTable-OddRow");
		    	  check = false;
		      } else {
		    	  rf.addStyleName(row, "FlexTable-EvenRow");
		    	  rf.addStyleName(++row, "FlexTable-EvenRow");
		    	  check = true;
		      }
		    }
	}
	  public void applyDataRowStyles(int header) {
		    HTMLTable.RowFormatter rf = super.getRowFormatter();
		    	for (int row = header; row < super.getRowCount(); ++row) {
			        rf.removeStyleName(row, "FlexTable-EvenRow");
			        rf.removeStyleName(row, "FlexTable-OddRow");
			    }
			    for (int row = header; row < super.getRowCount(); ++row) {
			      if ((row % 2) != 0) {
			    	  rf.addStyleName(row, "FlexTable-EvenRow");
			      } else {
			    	  rf.addStyleName(row, "FlexTable-OddRow");
			      }
			    }
	  }
	  
	  public void addColumn(KriImage kriImage) {
		  if(getRowCount() == 0){
			  insertRow(0);
		  }
	    
	    Widget widget = createCellWidget(kriImage);
	    int cell = super.getCellCount(0);
	    super.setWidget(0, cell, widget);
	    getRowFormatter().addStyleName(0, "FlexTable-Header2");
	  }
	  
	  public void addColumn(Object columnHeading, String style) {
		  if(getRowCount() == 0){
			  insertRow(0);
		  }
	    getRowFormatter().addStyleName(0, style);
	    Widget widget = createCellWidget(columnHeading);
	    int cell = super.getCellCount(0);
	    
	    widget.setWidth("100%");
	    widget.setHeight("20px");
		    widget.addStyleName("FlexTable-ColumnLabel");
	    
	    super.setWidget(0, cell, widget);
	    
	    super.getCellFormatter().addStyleName( 0, cell, "FlexTable-ColumnLabelCell");
	  }
	  public void addColumn(Object[] columnHeading) {
		  for(Object obj:columnHeading) {
			  addColumn(obj, "FlexTable-Header");
		  }
	  }
	  public Widget addRow(Object[] cellObjects) {
		  Widget widget = null;
		  int rowIndex = super.getRowCount();
	    for (int cell = 0; cell < cellObjects.length; cell++) {
	      widget = createCellWidget(cellObjects[cell]);
	      super.setWidget(rowIndex, cell, widget);
	      super.getCellFormatter().addStyleName(rowIndex, cell, "FlexTable-Cell");
	    }
	   return widget;
	  }
	  
	  public Widget createCellWidget(Object cellObject) {
	    Widget widget = null;
	    if (cellObject instanceof Widget)
	      widget = (Widget) cellObject;
	    else
	      widget = new Label(cellObject.toString());

	    return widget;
	  }

	  public void resetSno() {
	    HTMLTable.RowFormatter rf = super.getRowFormatter();
	    	for (int row = 1; row < super.getRowCount(); ++row) {
	    		Label label = (Label)super.getWidget(row, 0);
	    		label.setText(""+row);
		    }
	  }
	public void removeTableRows(){
		int length = super.getRowCount();
		for (int row = 1; row <length  ; row++) {
			super.removeRow(super.getRowCount() -1);
		}
	}

}
