package com.krispot.client.ui;

import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.HasHorizontalAlignment.HorizontalAlignmentConstant;
import com.google.gwt.user.client.ui.HasVerticalAlignment.VerticalAlignmentConstant;

public class KriHorizontalPanel extends HorizontalPanel {
	public KriHorizontalPanel() {
	}
	
	public KriHorizontalPanel(Integer border) {
		super.setBorderWidth(border);
	}
	
	public KriHorizontalPanel(String style) {
		super.setStyleName(style);
	}
	
	public KriHorizontalPanel(Integer border, String width, String height) {
		if(width != null)
			super.setWidth(width);
		if(height != null)
			super.setHeight(height);
		super.setBorderWidth(border);
	}

	public KriHorizontalPanel(Integer border, String width, String height, String style) {
		if(width != null)
			super.setWidth(width);
		if(height != null)
			super.setHeight(height);
		if(style != null)
			super.setStyleName(style);
	}

	public KriHorizontalPanel(Integer border, String width, String height, String style, Integer spacing) {
		if(width != null)
			super.setWidth(width);
		if(height != null)
			super.setHeight(height);
		if(spacing != null)
			super.setSpacing(spacing);
		if(style != null)
			super.setStyleName(style);
	}
	
	public void add(Widget widget, String width, String height) {
		super.add(widget);
		if(width != null)
			super.setCellWidth(widget, width);
		if(height != null)
			super.setCellHeight(widget, height);
	}

	public void add(Widget widget, String width, String height, VerticalAlignmentConstant vAlign, HorizontalAlignmentConstant hAlign) {
		super.add(widget);
		if(width != null)
			super.setCellWidth(widget, width);
		if(height != null)
			super.setCellHeight(widget, height);
		if(vAlign != null)
			super.setCellVerticalAlignment(widget, vAlign);
		if(hAlign != null)
			super.setCellHorizontalAlignment(widget, hAlign);
	}

	public void add(Widget widget, VerticalAlignmentConstant vAlign, HorizontalAlignmentConstant hAlign) {
		super.add(widget);
		if(vAlign != null)
			super.setCellVerticalAlignment(widget, vAlign);
		if(hAlign != null)
			super.setCellHorizontalAlignment(widget, hAlign);
	}
}