package com.krispot.client.ui;

import java.util.List;

import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.ListBox;
import com.krispot.client.common.ListBoxItem;
import com.krispot.client.common.Reset;
import com.krispot.client.common.Validate;
	
public class KriListBox extends ListBox implements Validate, Reset {
	public final static int KEY = 0;
	public final static int VALUE = 1;
	String errorMessage;
	HTML errorMessageOn;
	public KriListBox(boolean multiSelection, String[] listTypes, String errorMessage, HTML errorMessageOn) {
		super();
		for (int i = 0; i < listTypes.length; i++) {
			addItem(listTypes[i]);
	    }
		this.errorMessage = errorMessage;
		this.errorMessageOn = errorMessageOn;
		setWidth("173px");
	}
	public KriListBox(boolean multiSelection, String errorMessage, HTML errorMessageOn) {
		super();
		this.errorMessage = errorMessage;
		this.errorMessageOn = errorMessageOn;
		setWidth("173px");
	}
	public KriListBox(boolean multiSelection, String errorMessage, HTML errorMessageOn, String width, String height) {
		super();
		this.errorMessage = errorMessage;
		this.errorMessageOn = errorMessageOn;
		setSize(width, height);
	}
	public String getText() {
		return getValue(getSelectedIndex());
	}
	public void setText(String str, int option) {
		if(option == KEY){
			for (int index = 0; index < getItemCount(); index++) {
//				Window.alert(getValue(index)+"  - "+str);
				if(getValue(index).equals(str)) {
					setSelectedIndex(index);
					break;
				}
			}
		}else{ // defalut VALUE
			for (int index = 0; index < getItemCount(); index++) {
				if(getItemText(index).equals(str)) {
					setSelectedIndex(index);
					break;
				}
			}
		}
	}
	
	public void setItems(List<?> lbItem) {
		for (Object listBoxItem: lbItem) {
			addItem( ((ListBoxItem)listBoxItem).getValue(), ((ListBoxItem)listBoxItem).getId());
	    }
	}
	public void setItem(List<?> lbItem) {
		for (Object listBoxItem: lbItem) {
			addItem( ((ListBoxItem)listBoxItem).getValue(), ((ListBoxItem)listBoxItem).getValue());
	    }
	}
	public void addSelect() {
		addItem("select", "Select");
	}
	@Override
	public boolean isValidate() {
		if(getSelectedIndex() == 0) {
			errorMessageOn.setHTML(errorMessage);
			return false;
		}else{
			errorMessageOn.setHTML("&nbsp;");			
			return true;
		}
	}
	@Override
	public void reset() {
		setText("select", KriListBox.VALUE);
	}
}
