package com.krispot.client.ui;

import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.PasswordTextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.krispot.client.common.CSSStyle;
import com.krispot.client.common.Reset;
import com.krispot.client.common.Validate;
	
public class KriPasswordTextBox extends HorizontalPanel implements KeyUpHandler, Validate, Reset {

	private String strongPassword = "^(?=.*\\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[\\W]).{6,20}$";
	private String goodPassword = "^(?=.*\\W)(?=.*[\\w]).{6,20}$";
	private String poorPassword = "^[\\w\\W]{6,20}$";
	
	private PasswordTextBox textBox = new PasswordTextBox();
	private Image image = new Image("images/snitch-icon16.png");
	private String regExp;
	private HTML errorMessageOn;
	private String errorMessage;

	public KriPasswordTextBox() {
		
		super();
		this.regExp = "^\\.$";
		this.errorMessageOn = errorMessageOn;
		this.errorMessage = errorMessage;
		
		CSSStyle.zeroBorder(textBox);
		textBox.addKeyUpHandler(this);
		HorizontalPanel horizontalPanel = new HorizontalPanel();
		horizontalPanel.add(textBox);
		horizontalPanel.setCellWidth(textBox, "150px");
		horizontalPanel.setCellVerticalAlignment(textBox, HasVerticalAlignment.ALIGN_MIDDLE);
		
		horizontalPanel.setBorderWidth(0);
		horizontalPanel.setHeight("25px");
		
		
		horizontalPanel.setCellVerticalAlignment(image, HasVerticalAlignment.ALIGN_MIDDLE);
		KriHorizontalPanel hPanel = new KriHorizontalPanel();
		hPanel.add(horizontalPanel);
		hPanel.add(image, VerticalPanel.ALIGN_MIDDLE, null);
		image.setVisible(false);
		hPanel.setCellWidth(image, "20px");
		CSSStyle.maskedTextBox(hPanel);
		super.add(hPanel);
		super.setCellVerticalAlignment(horizontalPanel, HasVerticalAlignment.ALIGN_MIDDLE);
		
		
		super.setBorderWidth(0);
		super.setSpacing(0);
		super.setHeight("28px");
		
	}
	public KriPasswordTextBox(String regExp, String errorMessage, HTML errorMessageOn) {
		
		super();
		this.regExp = regExp;
		this.errorMessageOn = errorMessageOn;
		this.errorMessage = errorMessage;
		
		CSSStyle.zeroBorder(textBox);
		textBox.addKeyUpHandler(this);
		HorizontalPanel horizontalPanel = new HorizontalPanel();
		horizontalPanel.add(textBox);
		horizontalPanel.setCellWidth(textBox, "150px");
		horizontalPanel.setCellVerticalAlignment(textBox, HasVerticalAlignment.ALIGN_MIDDLE);
		
		horizontalPanel.setBorderWidth(0);
		horizontalPanel.setHeight("25px");
		
		
		horizontalPanel.setCellVerticalAlignment(image, HasVerticalAlignment.ALIGN_MIDDLE);
		HorizontalPanel hPanel = new HorizontalPanel();
		hPanel.add(horizontalPanel);
		hPanel.add(image);
		image.setVisible(false);
		hPanel.setCellWidth(image, "20px");
		CSSStyle.maskedTextBox(hPanel);
		super.add(hPanel);
		super.setCellVerticalAlignment(horizontalPanel, HasVerticalAlignment.ALIGN_MIDDLE);
		
		
		super.setBorderWidth(0);
		super.setSpacing(0);
		super.setHeight("28px");
		
	}
	public String getText() {
		return textBox.getText();
	}
	public int validate(int validateAllField) {
		
		String str = (""+this.getText()).trim();
		if(str.matches(regExp)) {
			image.setUrl("images/correct16.png");
			errorMessageOn.setHTML("&nbsp;");
			return validateAllField;
		}else{
			errorMessageOn.setHTML(errorMessage);
			image.setUrl("images/wrong16.png");
			return ++validateAllField;
		}	
	}
	@Override
	public void onKeyUp(KeyUpEvent event) {
		String str = (""+this.getText()).trim();
		if(str.matches(strongPassword)) {
			image.setUrl("images/green16.png");
			image.setVisible(true);
		}else if(str.matches(goodPassword)) {
			image.setUrl("images/blue16.png");
			image.setVisible(true);			
		}else if(str.matches(poorPassword)) {
			image.setUrl("images/yellow16.png");
			image.setVisible(true);
		}else{
			image.setUrl("images/red16.png");
			image.setVisible(true);
		}
	}
	public void setText(String loginPwd) {
		textBox.setText(loginPwd);
	}
	@Override
	public boolean isValidate() {
		return (validate(0)==0);
	}
	@Override
	public void reset() {
		textBox.setText("");
		image.setVisible(false);
	}
}
