package com.krispot.client.ui;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.Timer;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Image;
import com.krispot.client.Kri;

public class KriSecurityImage implements ClickHandler, Kri {
	Image image = new Image(appCtx + "SecurityImage.jpg");
	KriImage reloadImage = new KriImage(KriImage.RELOAD16);
	KriTextBox securityTextBox;

	public KriSecurityImage(String width, String height, String regExp, String messages, KriShowMessage showMessage) {
		image.setSize(width, height);
		reloadImage.addClickHandler(this);
		securityTextBox = new KriTextBox(regExp, messages, showMessage);
		
        Timer timer = new Timer() {
	        	@Override             
	        	public void run() {                 
	    			version++;
	    			image.setUrl(appCtx + "SecurityImage.jpg" + "?v" + version);
	    			if(appCtx != null) {
	    				cancel();
//	    				Window.alert("-");
	    			}
	        	}
        	};   
        	
        timer.run(); 
        timer.scheduleRepeating(2000); 
	}

	public Image getImage() {
		return image;
	}
	public KriImage getReloadImage() {
		return reloadImage;
	}
	public KriTextBox getSecurityTextBox() {
		return securityTextBox;
	}
	@Override
	public void onClick(ClickEvent event) {
		if(KriImage.RELOAD16.equals(((KriImage)event.getSource()).getId())) {
			version++;
			image.setUrl(appCtx + "SecurityImage.jpg" + "?v" + version);
		}
	}
	private static int version = 0; /* Download the new image every time*/
}
