package com.krispot.client.ui;

import com.google.gwt.dom.client.Style;
import com.google.gwt.dom.client.Style.TextDecoration;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.dom.client.Style.VerticalAlign;
import com.google.gwt.event.dom.client.FocusEvent;
import com.google.gwt.event.dom.client.FocusHandler;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.event.logical.shared.SelectionEvent;
import com.google.gwt.event.logical.shared.SelectionHandler;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.SuggestBox;
import com.google.gwt.user.client.ui.SuggestOracle;
import com.google.gwt.user.client.ui.TextBoxBase;
import com.google.gwt.user.client.ui.SuggestOracle.Suggestion;
import com.krispot.client.Kri;
import com.krispot.client.common.Reset;
import com.krispot.client.common.UserAction;
import com.krispot.client.common.Validate;

public class KriSuggestBox extends HorizontalPanel implements Kri, KeyUpHandler, Validate, Reset, AsyncCallback {
	
//	static {
//		css.ensureInjected();
//	}
	
	String regExp;
	String errorMessage;
	KriShowMessage errorMessageOn;
	private String value;
	class KriSuggestionBox extends SuggestBox {
		
		public KriSuggestionBox() {
			super();
		}

		public KriSuggestionBox(SuggestOracle oracle, TextBoxBase box,
				SuggestionDisplay suggestDisplay) {
			super(oracle, box, suggestDisplay);
		}

		public KriSuggestionBox(SuggestOracle oracle, TextBoxBase box) {
			super(oracle, box);
		}

		public KriSuggestionBox(SuggestOracle oracle, final KriSuggestBox kriSuggestBox) {
			super(oracle);
			this.addSelectionHandler(new SelectionHandler<SuggestOracle.Suggestion>() {
			
				        @Override
				        public void onSelection(SelectionEvent<Suggestion> event) {
				            String value = ((KriSuggestion) event.getSelectedItem()).getValue();
				            kriSuggestBox.setValue(value);
				        }
				    });
		}
	}
	
	public TextBoxBase getTextBox() {
		return suggestBox.getTextBox();
	}
	public String getText() {
		return suggestBox.getTextBox().getText();
	}
	public void setText(String text) {
		suggestBox.getTextBox().setText(text);
	}
	public TextBoxBase getSource() {
		return suggestBox.getTextBox();
	}
	public String getValue(){
		return value;
	}
	public void setValue(String value){
		this.value = value;
	}
	public void setPopupStyleName(String style) {
		suggestBox.setPopupStyleName(style);
	}
	KriSuggestionBox suggestBox;
	private SuggestOracle.Request req;
	private SuggestOracle.Callback callback;
	private Image image = new Image("images/correct16.png");
	
	
	CustomOracle customOracle = new CustomOracle(this);
	public CustomOracle getCustomOracle() {
		return customOracle;
	}
	public KriSuggestBox(String regExp, String errorMessage, KriShowMessage errorMessageOn, final String helpMessage, final KriHelpMessage helpMessageOn, String width,	String height) {
		this(regExp, errorMessage, errorMessageOn, width, height);
		getTextBox().addFocusHandler(new FocusHandler() {
			@Override
			public void onFocus(FocusEvent event) {
				helpMessageOn.setSuccess(helpMessage);
			}
		});
	}
	public KriSuggestBox(String regExp, String errorMessage, KriShowMessage errorMessageOn, String width, String height) {
		suggestBox = new KriSuggestionBox(customOracle, this);
		super.setWidth(width);
		super.setHeight(height);
	    this.regExp = regExp;
		this.errorMessageOn = errorMessageOn;
		this.errorMessage = errorMessage;
		suggestBox.getElement().getStyle().setBorderWidth(0, Unit.PX);
		suggestBox.getTextBox().addKeyUpHandler(this);
		suggestBox.getTextBox().getElement().getStyle().setVerticalAlign(VerticalAlign.MIDDLE);
		suggestBox.getTextBox().setWidth("99%");
		suggestBox.getTextBox().setHeight(height);
//		suggestBox.setPopupStyleName("searchBoxPopupStyle());
		
		
		HorizontalPanel horizontalPanel = new HorizontalPanel();
		horizontalPanel.add(suggestBox);
		horizontalPanel.setCellWidth(suggestBox, "99%");
		horizontalPanel.setCellVerticalAlignment(suggestBox, HasVerticalAlignment.ALIGN_MIDDLE);
		horizontalPanel.add(image);
		
		image.setVisible(false);
		image.getElement().getStyle().setVerticalAlign(VerticalAlign.MIDDLE);
		horizontalPanel.setCellWidth(image, "20px");
		
		horizontalPanel.setCellVerticalAlignment(image, HasVerticalAlignment.ALIGN_MIDDLE);
		
		add(horizontalPanel);
		setCellVerticalAlignment(horizontalPanel, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Style style = this.getElement().getStyle();
		style.setProperty("border", "1pt solid #92c1f0");
		style.setBackgroundColor("WHITE");
		
		setBorderWidth(0);
		setSpacing(0);
		setHeight("28px");

	}


	public int validate(int validateAllField) {
		String str = (""+suggestBox.getTextBox().getText()).trim();
		if(str.matches(regExp)) {
			errorMessageOn.setError("&nbsp;");
			return validateAllField;
		}else{
			errorMessageOn.setError(errorMessage);
			return ++validateAllField;
		}	
	}
	
	public void onFailure(Throwable caught) {
//		Failure.handler(caught);
		callback.onSuggestionsReady(req, new SuggestOracle.Response());
	}

	public void onSuccess(Object retValue) {
//		Window.alert("");
		SuggestOracle.Response f = (SuggestOracle.Response) retValue;
		callback.onSuggestionsReady(req, (SuggestOracle.Response) retValue);
	}
	
	
	public class CustomOracle<KriSuggestion> extends SuggestOracle {
		final KriSuggestBox kriSuggestBox;
		private int minChar;
		private UserAction userAction;
		
		public int getMinChar() { return minChar; }
		public void setMinChar(int minChar) { this.minChar = minChar; }
		public UserAction getUserAction() { return userAction; }
		public void setUserAction(UserAction userAction) { this.userAction = userAction; }
		public CustomOracle(KriSuggestBox kriSuggestBox) {
			this.kriSuggestBox = kriSuggestBox;
		}
		public boolean isDisplayStringHTML() {
			return true;
		}

		public void requestSuggestions(SuggestOracle.Request _req, SuggestOracle.Callback _callback) {
			if(_req.getQuery().length() >= minChar){
			req = _req;
			callback = _callback;
			userAction.execute(_req);
			}
		}

	}

	
	
//	IQuoteServiceAsync instance=(IQuoteServiceAsync) GWT.create(IQuoteService.class);   
	//ServiceDefTarget target = (ServiceDefTarget) instance;   
	//target.setServiceEntryPoint("/FileTracker/GWT/quote");   
	//return instance;

	public void onKeyUp(KeyUpEvent event) {
//		Window.alert("->"+suggestBox.getLimit());
		
		String str = (""+suggestBox.getTextBox().getText()).trim();
		if(str.length() == 0) {
			image.setVisible(false);
			errorMessageOn.setError("&nbsp;");
		}else{
			validate(0);
			image.setVisible(true);
		}
	}
	@Override
	public boolean isValidate() {
		return (validate(0)==0);
	}

	@Override
	public void reset() {
		suggestBox.getTextBox().setText("");
		value = null;
		image.setVisible(false);
	}
}
