package com.krispot.client.ui;

import com.google.gwt.dom.client.Style;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.TextArea;
import com.krispot.client.common.Reset;
import com.krispot.client.common.Validate;

public class KriTextArea extends TextArea implements KeyUpHandler, Validate, Reset {
	private String regExp;
	private HTML errorMessageOn;
	private String errorMessage;
	public KriTextArea(String regExp, String errorMessage, HTML errorMessageOn) {
		super();
		this.regExp = regExp;
		this.errorMessageOn = errorMessageOn;
		this.errorMessage = errorMessage;
		Style styleTextArea = super.getElement().getStyle();
		styleTextArea.setBackgroundColor("WHITE");
		super.addKeyUpHandler(this);
	}

	public KriTextArea() {
		super();
		applyStyle();
	}
	public KriTextArea(String width, String height) {
		super();
		Style styleTextArea = super.getElement().getStyle();
		setSize(width, height);
		applyStyle();
	}
	
	void applyStyle() {
		Style style = this.getElement().getStyle();
		style.setBorderWidth(0, Unit.PX);
		style.setBackgroundColor("WHITE");
		style.setProperty("border", "1pt solid #92c1f0");		
	}
	
	public String getText() {
		return super.getText();
	}
	
	public void setText(String str) {
		super.setText(str);
	}
	public int validate(int validateAllField) {
		
		String str = (""+this.getText()).trim();
		if(str.matches(regExp)) {
			errorMessageOn.setHTML("&nbsp;");
			return validateAllField;
		}else{
			errorMessageOn.setHTML(errorMessage);
			return ++validateAllField;
		}	
	}
	@Override
	public void onKeyUp(KeyUpEvent event) {
		String str = (""+this.getText()).trim();
		if(str.length() == 0) {
			errorMessageOn.setHTML("&nbsp;");
		}else{
			validate(0);
		}
	}

	@Override
	public boolean isValidate() {
		return (validate(0)==0);
	}

	@Override
	public void reset() {
		super.setText("");
	}
}
